#ifndef _BLOCKS_H_
#define _BLOCKS_H_

#include "custwind.h"

_CLASSDEF(TBlockWindows)
class _EXPORT TBlockWindows : virtual public TUnderlying
{
public:
	TBlockWindows(PCustColors SomeColors, PCustCursors
		SomeCursors)
		: TUnderlying(SomeColors, SomeCursors)
		{ };

   //Only need to draw the frame and title
	virtual void UserFrame(HDC DrawDC);
	virtual void UserTitle(HDC DrawDC);

	//I didn't say that the User functions were the only
   //ones that you can redefine
	virtual void UEraseBkGnd(RTMessage Msg);
	virtual void UCtlColor(RTMessage Msg);

protected:
	virtual LPSTR GetClassName()
		{ return (LPSTR)"BLOCKWINDOW"; };
};

/*******************************************************************
The following will create two new classes, one to create
Dialogs and the Other for Windows.  This isn't hard to
do because the major chunk can just be cut from the
CUSTWIND.H header file and change the names.
*******************************************************************/

_CLASSDEF(TBlockDialog)
class TBlockDialog : public TCustomDialog,
	public TBlockWindows
{
public:
	TBlockDialog(PTWindowsObject AParent, LPSTR AName,
		PCustColors Colors, PCustCursors Cursors,
		PTModule AModule = NULL)
		: TCustomDialog(AParent, AName, Colors, Cursors,
      	AModule) ,
		 TBlockWindows(Colors, Cursors),
		 TUnderlying(Colors, Cursors) {};
	TBlockDialog(PTWindowsObject AParent, int ResourceId,
		PCustColors Colors, PCustCursors Cursors,
		PTModule AModule = NULL)
		: TBlockWindows(Colors, Cursors),
		 TUnderlying(Colors, Cursors),
		 TCustomDialog(AParent, ResourceId, Colors, Cursors,
      	AModule) { };
};

_CLASSDEF(TBlockWindow)
class TBlockWindow : public TCustomWindow,
	public TBlockWindows
{
public:
	TBlockWindow(PTWindowsObject AParent, LPSTR ATitle,
		PCustColors Colors, PCustCursors Cursors,
		PTModule AModule = NULL)
		: TCustomWindow(AParent, ATitle, Colors, Cursors,
			AModule),
		TUnderlying(Colors, Cursors),
		TBlockWindows(Colors, Cursors) {};
};


#endif //_BLOCKS_H_

